unit MergeTable1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, WPRTEDefs, WPCTRMemo, WPCTRRich;

type
  TForm1 = class(TForm)
    WPRichText1: TWPRichText;
    Button1: TButton;
    Button2: TButton;
    WPRichText2: TWPRichText;
    procedure WPRichText1MailMergeGetText(Sender: TObject;
      const inspname: string; Contents: TWPMMInsertTextContents);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    TableNo : integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  WPRichText1.MergeText;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  Stream : TMemoryStream;
begin
  Stream := TMemoryStream.Create;
  try
    WPRichText1.SaveToStream(Stream);
    Stream.Position := 0;
    WPRichText1.LoadFromStream(Stream,'',True);
  finally
    Stream.Free;
  end;
end;

procedure TForm1.WPRichText1MailMergeGetText(Sender: TObject;
  const inspname: string; Contents: TWPMMInsertTextContents);
var
  Table, Row, Cell : TParagraph;
begin
  if inspname='TABLE1' then begin
    inc(TableNo);
    WPRichText2.Clear;
    WPRichText2.CheckHasBody;
    Table := WPRichText2.FirstPar.AppendNewPar.AppendNewTable(True);
    Row := Table;
    Row := Row.AppendNewRow(True);
    Cell := Row;
    Cell := Cell.AppendNewCell(True);
    Cell.ASet(WPAT_BorderFlags, WPBRD_DRAW_All4);
    Cell.SetText('This is Table '+IntToStr(TableNo));

    Cell := Cell.AppendNewCell(True);
    Cell.ASet(WPAT_BorderFlags, WPBRD_DRAW_All4);
    Cell.SetText('This is Table '+IntToStr(TableNo));

    Row := Row.AppendNewRow(True);
    Cell := Row;
    Cell := Cell.AppendNewCell(True);
    Cell.ASet(WPAT_BorderFlags, WPBRD_DRAW_All4);
    Cell.SetText('This is Table '+IntToStr(TableNo));

    Cell := Cell.AppendNewCell(True);
    Cell.ASet(WPAT_BorderFlags, WPBRD_DRAW_All4);
    Cell.SetText('This is Table '+IntToStr(TableNo));

    Contents.StringValue := WPRichText2.AsString;
  end;
end;

end.
